> For the complete documentation index, see [llms.txt](https://docs.platform.softwareone.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.platform.softwareone.com/developer-resources/rest-api/billing-api/invoice/create-invoice-attachment.md).

# Create invoice attachment

## Creates a new invoice attachment.

> Uploads a file as multipart/form-data with optional properties (name, description).

```json
{"openapi":"3.0.1","info":{"title":"Marketplace API","version":"5.0.5661-g83ffb015"},"servers":[{"url":"https://api.platform.softwareone.com"}],"paths":{"/public/v1/billing/invoices/{invoiceId}/attachments":{"post":{"tags":["InvoiceAttachments"],"summary":"Creates a new invoice attachment.","description":"Uploads a file as multipart/form-data with optional properties (name, description).","parameters":[{"name":"invoiceId","in":"path","description":"The ID of the invoice to which the attachment belongs.","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"multipart/form-data":{"schema":{"type":"object","properties":{"attachment":{"type":"object","properties":{"Name":{"type":"string","description":"The name of the attachment."},"Description":{"type":"string","description":"The description of the attachment."}},"description":"Json representation of the attachment"},"file":{"type":"string","description":"The file of the attachment.","format":"binary"}}},"encoding":{"attachment":{"contentType":"application/json"},"file":{"contentType":"application/octet-stream"}}}}},"responses":{"201":{"description":"Created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/InvoiceAttachment"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"InvoiceAttachment":{"type":"object","properties":{"audit":{"allOf":[{"$ref":"#/components/schemas/PlatformObjectAudit"}]},"$meta":{"allOf":[{"$ref":"#/components/schemas/PlatformMetadata"}],"nullable":true},"revision":{"type":"integer","format":"int32"},"name":{"type":"string","description":"Name of the attachment."},"type":{"allOf":[{"$ref":"#/components/schemas/BillingAttachmentType"}],"description":"Specifies the type of the attachment, such as input, output, or general attachment."},"filename":{"type":"string","description":"Represents the name of the file associated with the attachment."},"size":{"type":"integer","description":"Indicates the size of the file in bytes.","format":"int64","nullable":true},"contentType":{"type":"string","description":"Represents the MIME type of the file content."},"description":{"type":"string","description":"Provides a description of the attachment."},"isDeleted":{"type":"boolean","description":"Indicates whether the attachment has been marked as deleted."},"id":{"type":"string","description":"The unique identifier of the attachment."},"invoice":{"type":"object","allOf":[{"$ref":"#/components/schemas/InvoiceRef"}]},"isExternal":{"type":"boolean","description":"Indicates whether the attachment is stored externally"}},"additionalProperties":false,"description":"Represents an attachment associated with an invoice in the billing system."},"PlatformObjectAudit":{"type":"object","properties":{"created":{"allOf":[{"$ref":"#/components/schemas/PlatformObjectEvent"}],"nullable":true},"updated":{"allOf":[{"$ref":"#/components/schemas/PlatformObjectEvent"}],"nullable":true}},"additionalProperties":false},"PlatformObjectEvent":{"type":"object","properties":{"at":{"type":"string","format":"date-time","nullable":true},"by":{"type":"object","allOf":[{"$ref":"#/components/schemas/PlatformIdentityRef"}]}},"additionalProperties":false},"PlatformIdentityRef":{"type":"object","properties":{"id":{"type":"string"},"name":{"type":"string"},"icon":{"type":"string","nullable":true},"revision":{"type":"integer","format":"int32"}},"additionalProperties":false},"PlatformMetadata":{"type":"object","properties":{"omitted":{"type":"array","items":{"type":"string"}}},"additionalProperties":false},"BillingAttachmentType":{"enum":["Attachment","Input","Output"],"type":"string","description":"Represents the type of billing attachment."},"InvoiceRef":{"type":"object","properties":{"revision":{"type":"integer","format":"int32"},"id":{"type":"string","description":"The unique identifier of the invoice."}},"additionalProperties":false,"description":"Represents an invoice entity in the billing system."},"ProblemDetails":{"type":"object","properties":{"type":{"type":"string","nullable":true},"title":{"type":"string","nullable":true},"status":{"type":"integer","format":"int32","nullable":true},"detail":{"type":"string","nullable":true},"instance":{"type":"string","nullable":true}},"additionalProperties":{}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.platform.softwareone.com/developer-resources/rest-api/billing-api/invoice/create-invoice-attachment.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
